<template>
  <div>
    <b-alert :show="isPosted" variant="success"
      >Le plat a bien été enregistré</b-alert
    >
    <div>
      <b-form @submit="create" @reset="onReset" v-if="show">
        <!-- envoyer le formulaire via submit -->
        <!-- on bind le champs text à un objet form en utilisant v-model -->
        <b-form-group
          id="name_dish"
          label="Nom du plat"
          label-for="name_dish"
          description="Le nom du plat doit être le plus précis possible"
        >
          <b-form-input
            id="name_dish"
            v-model="dish.name_dish"
            type="text"
            placeholder="Nom du plat"
            required
          ></b-form-input>
        </b-form-group>

        <b-form-group
          id="description_dish"
          label="Descriptif du plat :"
          label-for="description_dish"
          description="Le descriptif du plat doit être le plus complet possible"
        >
          <b-form-input
            id="description_dish"
            v-model="dish.description_dish"
            placeholder="Saisir le descriptif du plat"
            required
          ></b-form-input>
        </b-form-group>
        <b-form-group id="price_dish" label="Prix :" label-for="price_dish">
          <b-form-select
            id="price_dish"
            v-model="dish.price_dish"
            :options="price_dish"
            required
          ></b-form-select>
        </b-form-group>
        <b-form-group
          id="new_price_dish"
          label="Nouveau prix :"
          label-for="new_price_dish"
        >
          <b-form-select
            id="new_price_dish"
            v-model="dish.new_price_dish"
            :options="new_price_dish"
          ></b-form-select>
        </b-form-group>

        <b-form-group
          id="allergens_dish"
          label="Allergènes du plat :"
          label-for="allergens_dish"
          description="La liste des allergènes du plat doit être le plus complète possible"
        >
          <b-form-input
            id="allergens_dish"
            v-model="dish.allergens_dish"
            placeholder="Saisir la liste des allergènes du plat"
            required
          ></b-form-input>
        </b-form-group>

        <b-form-group id="weight_dish" label="Poids du plat :">
          <b-form-input
            id="weight_dish"
            v-model="dish.weight_dish"
            placeholder="Saisir le poids du plat"
            required
          ></b-form-input>
        </b-form-group>

        <b-form-group
          id="nutritional_values_dish"
          label="Valeur nutritionnelle du plat :"
        >
          <b-form-input
            id="nutritional_values_dish"
            v-model="dish.nutritional_values_dish"
            placeholder="Saisir la valeur nutritionnelle du plat"
            description="La liste le grammage de glucide, lipide et proteine"
            required
          ></b-form-input>
        </b-form-group>

        <b-form-group id="picture_link" label="Image du plat :">
          <b-form-input
            id="picture_link"
            v-model="dish.picture_link"
            placeholder="Saisir le lien de l'image"
            required
          ></b-form-input>
        </b-form-group>
        <b-form-group
          id="category_dish"
          label="Catégorie de plat :"
          label-for="category_dish"
        >
          <b-form-select
            id="category_dish"
            v-model="dish.category_dish"
            :options="category_dish"
            required
          ></b-form-select>
        </b-form-group>
        <b-button type="submit" variant="primary">Enregistrer</b-button>
        <b-button type="reset" variant="danger">Effacer</b-button>
      </b-form>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      dish: {
        name_dish: "",
        description_dish: "",
        allergens_dish: "",
        weight_dish: "",
        nutritional_values_dish: "",
        picture_link: "",
        category_dish: "",
        new_price_dish: null,
        price_dish: null,
      },
      new_price_dish: [
        { text: "Sélectionner un nouveau prix", value: null },
        "non soldé",
        3.50,
        9.90,
        2.50,
      ],
      price_dish: [
        { text: "Sélectionner un prix", value: null },
        5.50,
        11.90,
        3.90,
      ],
      category_dish: [
        { text: "Sélectionner une catégorie", value: null },
        "Entrée",
        "Plat",
        "Dessert",
        "Boisson",
      ],
      show: true,
      isPosted: false,
    };
  },

  methods: {
    create() {
      console.log(this.dish);
      this.$store.dispatch("postDish", this.dish);
      this.isPosted = true;
    },
    onReset(event) {
      event.preventDefault();
      // Reset our form values
      this.dish.name_dish = "";
      this.dish.description_dish = "";
      this.dish.price_dish = "";
      this.dish.new_price_dish = "";
      this.dish.allergens_dish = "";
      this.dish.weight_dish = "";
      this.dish.nutritional_values_dish = "";
      this.dish.picture_link = "";
      this.dish.price_dish = null;
      this.dish.new_price_dish = null;
      this.dish.category_dish = null;

      // Trick to reset/clear native browser form validation state
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    },
  },
};
</script>
